# Change Log

All notable changes to the "bytepower-cms" extension will be documented in this file.

## [0.3.5] - 2022-10-26

### Added

-   配置添加 operator 字段，用于区分操作人员（无字段时提示）
-   上传更新接口使用 authkey 字段来提交操作人员邮箱（无效时报错）
-   清除状态时，刷新整个文件树，可以对新文件提供右键操作

### Changed

-   模板字符串、html 字段、文案和函数命名更语义化更易理解
-   优化 interface 命名，并补充缺失的类型声明
-   兼容接口返回的错误信息格式
-   修改插件激活时机（编辑 json 时不再激活，同时避免插件 .config.json 文件修改后并重启 vscode 后，执行上传操作【资源管理器界面】在插件初始化【异步加载 collection】未完成时，使用旧 authkey 数据的问题）

### Fixed

-   升级依赖包版本，避免调试时报错
-   修复上传配置时不填写描述会延续上一次提交的描述的问题

## [0.3.4] - 2022-07-04

### Added

-   异步并发处理程序支持传入回调，以便正确统计上传或下载队列的任务状态
-   批量上传也使用异步并发处理程序（从检测版本就开始处理）
-   并发时异步请求完成时才记录单项配置的状态，并在全部完成后保存到本地存储
-   并发时每 5 秒提示一次进度，避免长队列的空闲期用户得不到反馈
-   添加清除本地存储状态的功能

### Changed

-   插件激活初始化时不再自动下载文件
-   并发处理程序默认请求值调整为 10 条，同时上传并发数统一为 10，下载并发数统一为 20
-   优化提示语

### Fixed

-   优化上传预检功能，避免上传不存在的文件报错

## [0.3.3] - 2021-03-31

### Added

-   新建配置文件时添加 json 格式校验
-   下载配置列表时，不只是同步新增情况，对删除的条目也同步刷新

### Fixed

-   修复下载时检测对比条目，对新建项没有做本地状态容错判断导致下载出错的 bug

## [0.3.2] - 2021-02-23

### Added

-   配置文件添加 ignore_collections 字段，可以支持在 app 列表下忽略指定的 collection

### Fixed

-   修复获取待更新条目后，没有使用该数据，还是使用全部下载导致下载报错的 bug
-   修复插件配置文件项缺少 collections 字段导致初始化树目录包括整体下载出错的 bug

## [0.3.1] - 2021-01-22

### Changed

-   批量下载时检测需更新条目和下载条目针对并发请求进行优化，避免在配置量大的情况下造成巨量请求影响服务器性能
-   插件的命名和相关文案进行优化更新（BytePower CMS - BP Remote Config）

## [0.3.0] - 2021-01-07

### Changed

-   后端接口从 strapi 迁移到 bp service
-   根据新配置文件结构（增加 app 层级）、新接口重构原有功能代码
-   批量上传和下载功能由 tag 节点移至 collect 节点
-   优化提示语：统一格式和语言

## [0.2.7] - 2020-12-17

### Added

-   除了现有的强制批量下载，额外提供仅批量下载更新文件的功能
-   添加对比修改功能，用于本地文件与线上的最新生效版本进行对比

### Changed

-   批量下载成功后，统一提示，不再提醒单个文件下载成功

## [0.2.6] - 2020-11-10

### Changed

-   恢复发布到 App Server 的功能

## [0.2.5] - 2020-11-09

### Added

-   添加通过 webview 展示最新配置文件地址的功能

## [0.2.4] - 2020-11-03

### Fixed

-   修复衰减系数快速批量生成功能中的 bug

## [0.2.2] - 2020-08-21

### Added

-   配置文件支持同一分组下批量上传和下载，上传完毕统一通知异常信息

## [0.2.1] - 2020-08-10

### Added

-   配置文件支持分组，配置文件的条目添加 tag 字段，可以在上传配置时设置 tag，可以后期进行单独修改

### Changed

-   上传配置时，config name 改为非必填，默认为当前文件名

## [0.2.0] - 2020-07-24

### Added

-   添加 JSON 文件内点击 key 值在右下角状态栏里显示其 path 路径的功能，点击即可复制
-   添加根据生成描述文件和衰减系数快速批量生成多个配置文件的功能（支持插件界面按钮、资源管理器右键两种调用方式，前者是整体，后者是局部）

### Changed

-   上传配置时需要的文件夹对应服务端信息由 .config.json 实体文件改为 space state 来存储，避免和项目自有 json 文件混淆

### Fixed

-   修复获取最新生效配置时使用 id 而非唯一标识值 config_id 造成 commit_code 信息错误的 bug
-   修复整体或单独下载配置后，没有刷新本地状态造成 commit_code 不一致的 bug
-   修改更新配置文件的接口调用顺序，避免取消后还会上传文件的问题

## [0.1.7] - 2020-06-13

### Changed

-   单个接口配置的本地特征识别码添加环境变量，避免同名混淆
-   上传 JSON 配置文件时，进行校验，避免非法格式造成无效配置

## [0.1.6] - 2020-05-28

### Changed

-   上传配置交互优化：按 esc 统一取消当前操作，回车则继续当前操作

## [0.1.5] - 2020-05-25

### Added

-   查询配置列表时，支持传入过滤参数，减少返回数据

### Changed

-   版本对比功能优化：对比时进行查询过滤，返回最近相邻版本，而非生成树结构时保存所有兄弟版本
-   查询配置列表时传参过滤结果：因为版本对比已经优化，现用现查，所以配置列表查询不用再返回全量数据
-   快速生成常用查询参数，减少重复代码

### Fixed

-   修复了登录授权过期后无权请求接口的 bug（1、在下载整体配置时，强制更新登录信息；2、保存登录 token 时记录时间，用于判断是否过期）

## [0.1.4] - 2020-05-20

### Added

-   添加了上传更新配置时，可以同时更新 desc 字段的功能

### Fixed

-   修复了日志记录的日期判断规则不完善（判断距离上一次操作是否满 24 小时，应该判断上一次操作是否为今天）导致无法正常清空前一天记录的 bug
-   上传更新配置时，添加 loading 标记，避免同时多次上传，造成条目重复的问题
-   查询配置列表时按状态过滤：从源头直接过滤，避免超出 limit 条数再进行后期过滤，数据不全
-   查询配置列表时按状态过滤：撤回从源头直接过滤功能，因为会导致版本对比失效，相邻兄弟版本都被过滤了；另外去除默认限制条数，返回全量数据

## [0.1.3] - 2020-05-16

### Added

-   添加了日志记录功能，用于报错后 debug
-   添加了强制下载刷新单项配置的功能
-   添加了配置列表按 config id 排序的功能

### Changed

-   使用 webpack 打包，减少尺寸
-   基础工具库的请求方法添加 catch 步骤，抛出 error 便于日志记录
-   基础工具库的列表请求参数添加过滤条件，直接从源头过滤，避免请求条数超限导致数据不全的问题

### Fixed

-   修复了参数数据类型不符合造成接口报错的 bug

## [0.1.2] - 2020-05-12

### Added

-   添加了发布 App Server 功能，用于配置文件更新成功后推到正式环境使其生效

### Fixed

-   修复了因 VSCode 升级 1.45 造成的 diff 功能失效的 bug

## [0.1.1] - 2020-04-24

### Added

-   添加了 diff 功能，用于本地文件和线上的上一版本进行对比

## [0.1.0] - 2020-04-16

### Added

-   Initial release
