# BytePower Remote Config Assistant README

A tool as app config manager for BytePower Remote Config.

## Features

按照配置文件，自动读取 Remote Config 后台的数据，并生成树形菜单。

提供

-   新建配置
-   单个或批量（同一 collection、整体）下载配置
-   单个或批量（同一 collection）更新配置
-   查看同一 collection 下所有配置的链接地址
-   查看单个配置详情描述
-   比较本地文件与线上的上一个版本的差异
-   比较本地文件与线上的最新版本的差异
-   通过给配置文件添加 tag 来支持分组，方便操作
-   根据包含衰减系数的生产描述文件及配套路径文件快速批量（指定文件夹、整体环境）生成多个配置文件
-   针对 JSON 文件提供状态栏显示激活焦点所在 path 路径以及复制支持（用于上条配套路径生成）

等功能

## Extension Settings

首先：新建一目录，目录内创建 `.config` 文件夹，文件夹内新建 `.config.json` 文档，内容格式如下：

```json
{
    "environments": [
        {
            "environment_name": "Test", // 配置根环境名称，必须唯一。一般用于区分测试和开发环境，本地会同步生成同名文件夹
            "domain": "console.bytepowerapp.cn", // 配置当前环境的 api 地址的一级域名
            "operator": "someone@ihandysoft.com", // 配置当前环境的操作用户，必须为有效 BP 用户，为空的话仅能执行查询操作，无法上传配置文件
            "applications": [
                {
                    "application_name": "test-app", // 配置 App 名称，必须唯一。用于树形菜单显示，本地会同步生成同名文件夹
                    "application_id": "APP3HGLRQILDI", // 配置 App ID，必须唯一。用于 api 接口访问
                    "ignore_collections": [
                        "prometheus_group" // 配置需要忽略的 collection，用于在树形菜单下隐藏某些不需要显示的项，可选
                    ]
                },
                {
                    "application_name": "prometheus",
                    "application_id": "APPDDT5JEIE"
                }
            ]
        },
        // 可配置多个环境，用名字区分
        ...
    ]
}
```

其次：将该目录添加为 VSCode 的首要 workspace，然后点击左栏插件图标，激活插件，即可按配置读取后台数据并渲染为树形菜单。

树形菜单按 env -> app -> collection -> [tag] -> config file 层次进行渲染，可以点击依次展开。点击最终节点文件时，下载该配置文件并在编辑器内显示。

最后，支持的操作：

-   插件顶部右侧为全局操作图标，提供操作：

    -   Download all from BytePower Remote Config（整体下载配置）
    -   Reset state（清除插件存储状态）

-   插件树形菜单中 collection 节点右侧操作图标，提供操作：

    -   Show config files link（显示该 collection 的全部配置链接）
    -   Upload to BytePower Remote Config（上传全部配置）
    -   Download from BytePower Remote Config（下载全部配置）

-   插件树形菜单中的最终文件节点，提供右键操作：

    -   Add tag（添加或修改标签）
    -   Compare Last Version Difference（比较与上一个版本的差异）
    -   Compare Local Change（比较与最新版本的差异）
    -   Detail（查看详情）
    -   Upload to BytePower Remote Config（上传配置）
    -   Download from BytePower Remote Config（下载配置）

-   VSCode 的资源管理器内，对文件点击右键，可以选择 Upload to BytePower Remote Config 新建并上传配置

## Release Notes

详情请查看 [CHANGELOG.md](https://github.com/Microsoft/vscode/blob/master/./CHANGELOG.md) 文档

**Enjoy!**
