"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const vscode = __importStar(require("vscode"));
const libPath = __importStar(require("path"));
const utils = __importStar(require("./utils"));
class NodeItem extends vscode.TreeItem {
    // 提供一个 parent，当它是 null 时则代表它是根节点
    constructor(label, collapsibleState, parent) {
        super(label, collapsibleState);
        this.label = label;
        this.collapsibleState = collapsibleState;
        this.parent = parent;
        this.command = this.collapsibleState === vscode.TreeItemCollapsibleState.None
            ? {
                command: 'fileExplorer.open',
                arguments: [this],
                title: 'Open'
            }
            : void 0;
        // 对文件和文件夹进行分类 如果 collapsibleState 是 None 则代表它是文件
        this.iconPath = {
            light: this.collapsibleState === vscode.TreeItemCollapsibleState.None
                ? utils.lightRes('file.svg')
                : utils.lightRes('folder.svg'),
            dark: this.collapsibleState === vscode.TreeItemCollapsibleState.None
                ? utils.darkRes('file.svg')
                : utils.darkRes('folder.svg')
        };
        this.contextValue = this.collapsibleState === vscode.TreeItemCollapsibleState.None ? 'fileItem' : 'dirItem';
    }
    get path() {
        return this.parent ? libPath.join(this.parent.path, this.label) : this.label;
    }
}
exports.default = NodeItem;
//# sourceMappingURL=file-item.js.map