"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.messageHandler = exports.invokeCallback = exports.getWebViewContent = exports.createWebview = exports.darkRes = exports.lightRes = exports.msg = exports.writeAuth = exports.readAuth = exports.readConfigState = exports.getRoot = exports.checkValue = exports.parseURL = exports.getConfigName = exports.genItemConfigPath = exports.genCommonConfigPath = exports.genParam = exports.getCollectDetail = exports.getTreeEnv = exports.genLimitTask = exports.prePublish = exports.updateConfig = exports.uploadConfig = exports.getLatestConfig = exports.getConfigList = exports.getCollectList = exports.getAuth = exports.readFile = exports.deleteFolder = exports.getDownloadList = exports.createConfigFile = exports.createLogFile = exports.createFolder = exports.deepClone = exports.flatFromArr = exports.pick = exports.setProp = exports.arr2dot = exports.getProp = exports.isEmpty = exports.isNumber = exports.isNil = void 0;
const vscode = __importStar(require("vscode"));
const libPath = __importStar(require("path"));
const libFs = __importStar(require("fs"));
const crypto = __importStar(require("crypto"));
const http = __importStar(require("http"));
const https = __importStar(require("https"));
const libUrl = __importStar(require("url"));
const form_data_1 = __importDefault(require("form-data"));
const config_item_1 = require("./config-item");
const constant_1 = require("./constant");
/* Time Method */
// 判断日期是否为同一天
function sameDay(first, second) {
    return first.getFullYear() === second.getFullYear() && first.getMonth() === second.getMonth() && first.getDate() === second.getDate();
}
/* Object Method */
// 是否为 falsey 值，避免误判 0 和 false
function isNil(value) {
    return value === null || value === undefined || value === '';
}
exports.isNil = isNil;
// 是否为数字或者纯数字字符串，避免使用 isNaN 时误判空字符串和 null
function isNumber(value) {
    return !isNaN(value - parseFloat(value));
}
exports.isNumber = isNumber;
// 是否为空对象
function isEmpty(target) {
    if (target === null || target === undefined) {
        return true;
    }
    return Object.keys(target).length === 0 && target.constructor === Object;
}
exports.isEmpty = isEmpty;
/**
 * 安全读取对象深度嵌套的属性，遇到不存在的属性会返回 undefined，避免报错
 *
 * @param   {object}    target  目标对象
 * @param   {string}    path    属性路径，为点语法组成的字符串，支持字面量，可以使用模板字符串支持变量
 * @return  {any}               返回对象的属性值
 * @用例    getProp(obj, 'a.b.c') => obj.a.b.c
 * @用例    getProp(obj, `a.${this.b}.c`) => obj.a[this.b].c
 */
function getProp(target, path) {
    return path.split('.').reduce((obj, key) => {
        return obj && obj[key];
    }, target);
}
exports.getProp = getProp;
// 转换属性路径字符串中数组表示法为点语法 'list[0].show["1"].deep' => 'list.0.show.1.deep'，便于 getProp/setProp 方法使用
function arr2dot(path) {
    return path.replace(/\[/g, '.').replace(/\]/g, '').replace(/'/g, '').replace(/"/g, '');
}
exports.arr2dot = arr2dot;
// 设置对象深度嵌套的属性（属性路径为点语法组成的字符串）
function setProp(target, path, value) {
    path.split('.').forEach((key, index, arr) => {
        if (index < arr.length - 1) {
            target = target[key];
        }
        else {
            target[key] = value;
        }
    });
}
exports.setProp = setProp;
// MDN 的另外一种方案: https://developer.mozilla.org/zh-CN/docs/Web/JavaScript/Reference/Global_Objects/eval
function setDescendantProp(target, path, value) {
    let arr = path.split('.');
    while (arr.length > 1) {
        target = target[arr.shift()];
    }
    target[arr[0]] = value;
}
// 获取对象的指定属性重新生成新对象
function pick(target, props = []) {
    if (!Array.isArray(props) || !props.length) {
        return target;
    }
    let flag = {};
    props.forEach((key) => {
        flag[key] = deepClone(target[key]);
    });
    return flag;
}
exports.pick = pick;
// 获取对象数组中指定属性重新生成新数组
function flatFromArr(array, key) {
    return array.map((item) => {
        return item[key];
    });
}
exports.flatFromArr = flatFromArr;
// 深复制（支持基础类型以及对象、数组、函数、日期、正则；不支持 Map、Set、Symbol、Error 等类型，不支持循环引用）
function deepClone(target) {
    if (!target || typeof target !== 'object') {
        return target;
    }
    if (target instanceof RegExp) {
        return new RegExp(target);
    }
    if (target instanceof Date) {
        return new Date(target);
    }
    let clone;
    if (Array.isArray(target)) {
        clone = [];
    }
    else {
        clone = Object.create(Object.getPrototypeOf(target));
    }
    Object.keys(target).forEach((key) => {
        clone[key] = deepClone(target[key]);
    });
    return clone;
}
exports.deepClone = deepClone;
/* Nodejs Method */
/**
 * 创建文件夹
 */
function createFolder(...dir) {
    let fullPath = libPath.join(getRoot(vscode), ...dir);
    if (!libFs.existsSync(fullPath)) {
        libFs.mkdirSync(fullPath, { recursive: true });
    }
}
exports.createFolder = createFolder;
function createLogFile(msg) {
    let parentPath = libPath.join(getRoot(vscode), constant_1.rootConfigFolder);
    let fullPath = libPath.join(parentPath, constant_1.debugFileName);
    if (!libFs.existsSync(parentPath)) {
        libFs.mkdirSync(parentPath, { recursive: true });
    }
    let today = new Date();
    let opt = {
        flag: 'a'
    };
    if (libFs.existsSync(fullPath)) {
        const { mtime } = libFs.statSync(fullPath);
        if (!sameDay(today, mtime)) {
            opt.flag = 'w';
        }
    }
    libFs.writeFile(fullPath, '\n ' + today.toLocaleString('zh-CN') + ' -- ' + JSON.stringify(msg), opt, (err) => { });
}
exports.createLogFile = createLogFile;
/**
 * 创建配置文件
 */
function createConfigFile(config, ...dir) {
    let fullPath = libPath.join(getRoot(vscode), ...dir);
    return new Promise((resolve, reject) => {
        let empty = config.force || !libFs.existsSync(fullPath);
        if (empty) {
            libFs.mkdir(libPath.dirname(fullPath), { recursive: true }, (err) => {
                if (err) {
                    throw err;
                }
                getConfigFile(config)
                    .then((result) => {
                    libFs.writeFile(fullPath, result, (err) => {
                        if (err) {
                            reject();
                        }
                        else {
                            resolve();
                        }
                    });
                })
                    .catch((err) => {
                    reject();
                });
            });
        }
        else {
            reject();
        }
    });
}
exports.createConfigFile = createConfigFile;
/**
 * 获取需要下载的配置文件（包括本地不存在和本地非最新两种情况）
 */
function getDownloadList(list, param) {
    return __awaiter(this, void 0, void 0, function* () {
        let arr = [];
        for (const item of list) {
            // 本地配置相比线上版本非最新的情况
            let configItemObj = param.configItemObj;
            let localCommit = configItemObj[item.config_id];
            // 本地配置文件不存在的情况
            let name = getConfigName(item);
            let fullPath = libPath.join(getRoot(vscode), param.path, name);
            if (!localCommit || localCommit < item.commit_code || !libFs.existsSync(fullPath)) {
                arr.push(item);
            }
        }
        return arr;
    });
}
exports.getDownloadList = getDownloadList;
/**
 * 删除非空文件夹
 */
function deleteFolder(dir) {
    if (libFs.existsSync(dir)) {
        libFs.readdirSync(dir).forEach((file) => {
            const curPath = libPath.join(dir, file);
            if (libFs.lstatSync(curPath).isDirectory()) {
                // recursion
                deleteFolder(curPath);
            }
            else {
                // delete file
                libFs.unlinkSync(curPath);
            }
        });
        libFs.rmdirSync(dir);
    }
}
exports.deleteFolder = deleteFolder;
/**
 * 安全读取指定文件并解析内容
 */
function readFile(path, callback, fallback) {
    try {
        let str = libFs.readFileSync(path, 'utf-8');
        callback(str);
    }
    catch (err) {
        if (fallback) {
            fallback({
                msg: 'An error occurred'
            });
        }
        else if (err.code === 'ENOENT') {
            msg('Config file does not exist', constant_1.msgType.error);
        }
        else {
            msg('An error occurred: ' + err, constant_1.msgType.error);
        }
    }
}
exports.readFile = readFile;
/**
 * 从后端接口获取数据的相关函数
 */
// 获取登录 token
function getAuth(props) {
    let { username, password, domain } = props;
    let param = {
        identifier: username,
        password: password
    };
    return ajax({
        method: 'POST',
        server: domain,
        path: '/auth/local',
        data: param
    }).then((result) => {
        let auth = 'Bearer ' + result.jwt;
        return auth;
    });
}
exports.getAuth = getAuth;
// 获取 App 下所有 collection 列表
function getCollectList(props) {
    let { server, authkey, appid } = props;
    return ajax({
        method: 'GET',
        server: server,
        path: `/remote_config/${appid}`,
        auth: authkey + ''
    })
        .then((result) => {
        return result.remote_config.collections;
    })
        .catch((err) => {
        msg(constant_1.msgText.ajaxFail, constant_1.msgType.error);
        throw {
            interface: 'getCollectList',
            msg: err
        };
    });
}
exports.getCollectList = getCollectList;
// 获取 collection 下所有最新生效配置列表
function getConfigList(props) {
    let { server, authkey, appid, collect } = props;
    return ajax({
        method: 'GET',
        server: server,
        path: `/remote_config/${appid}/${collect}/latest`,
        auth: authkey + ''
    })
        .then((result) => {
        return result.remote_config.configs;
    })
        .catch((err) => {
        msg(constant_1.msgText.ajaxFail, constant_1.msgType.error);
        throw {
            interface: 'getConfigList',
            msg: err
        };
    });
}
exports.getConfigList = getConfigList;
// 获取指定 ID 的最新生效配置项信息
function getLatestConfig(props) {
    let { server, authkey, appid, collect, config_id } = props;
    return ajax({
        method: 'GET',
        server: server,
        path: `/remote_config/${appid}/${collect}/config_id/${config_id}`,
        auth: authkey + ''
    })
        .then((result) => {
        return getProp(result, `remote_config.configs.${0}`) || {};
    })
        .catch((err) => {
        msg(constant_1.msgText.ajaxFail, constant_1.msgType.error);
        throw {
            interface: 'getLatestConfig',
            msg: err
        };
    });
}
exports.getLatestConfig = getLatestConfig;
// 获取指定配置下 json 文件（指定 commit code 则获取具体版本）
function getConfigFile(props) {
    let { server, authkey, appid, collect, config_id, commitCode } = props;
    let url = `/remote_config_file/${appid}/${collect}/${config_id}`;
    if (commitCode) {
        url += '/' + commitCode;
    }
    return ajax({
        method: 'GET',
        server: server + '',
        path: url,
        auth: authkey + '',
        origin: true
    }).then((result) => {
        return result;
    });
}
// 上传 json 文件并新建或更新配置项
function uploadConfig(props) {
    let { server, authkey, appid, collect, filepath, param } = props;
    if (!libFs.existsSync(filepath)) {
        return Promise.reject({
            type: 'notfound',
            msg: 'File is not exist'
        });
    }
    let form = new form_data_1.default();
    let stream = libFs.createReadStream(filepath);
    let fsHash = crypto.createHash('sha256');
    let buffer = libFs.readFileSync(filepath);
    fsHash.update(buffer);
    let hash = fsHash.digest('hex');
    form.append('config_file', stream);
    form.append('app_id', appid);
    form.append('collection_name', collect);
    form.append('config_id', Number(param.config_id));
    form.append('description', param.description);
    form.append('hash_value', hash);
    form.append('tag', param.tag);
    /* If send a buffer, we need to set a filename for the data field, otherwise the buffer isn't uploaded as a file
    See: https://github.com/form-data/form-data/issues/468
    or: https://stackoverflow.com/questions/43913650/how-to-send-a-buffer-in-form-data-to-signserver
    let buffer = libFs.readFileSync(filepath);
    form.append('file', buffer, { filename: 'my-file.ext' })
    */
    return ajax({
        method: 'POST',
        server: server,
        path: '/remote_config/commit/single',
        auth: authkey + '',
        moreHeader: form.getHeaders(),
        moreAction: (request) => {
            form.pipe(request);
        }
    })
        .then((result) => {
        return result.remote_config.configs[0];
    })
        .catch((err) => {
        throw {
            interface: 'uploadConfig',
            msg: err
        };
    });
}
exports.uploadConfig = uploadConfig;
// 更新配置项
function updateConfig(props) {
    let { server, authkey, appid, collect, param, config_id } = props;
    return ajax({
        method: 'PUT',
        server: server,
        path: `/remote_config/${appid}/${collect}/${config_id}`,
        data: param,
        auth: authkey + ''
    })
        .then((result) => {
        return result;
    })
        .catch((err) => {
        throw {
            interface: 'updateConfig',
            msg: err
        };
    });
}
exports.updateConfig = updateConfig;
// 发布配置项到 appserver
function publishConfig(props) {
    let { server, authkey, param, url } = props;
    return ajax({
        method: 'POST',
        protocol: 'http',
        server: server,
        path: url,
        data: param,
        auth: authkey + ''
    })
        .then((result) => {
        return result;
    })
        .catch((err) => {
        throw {
            interface: 'publishConfig',
            msg: err
        };
    });
}
// 根据设置中的部署项进行发布预处理
function prePublish(publishUrl, result, post) {
    if (!publishUrl) {
        return Promise.resolve();
    }
    let newConfigUrl = getProp(result, constant_1.fileUrlPath);
    let url = parseURL(publishUrl);
    let clone = deepClone(post);
    clone.server = url.host;
    clone.url = url.path;
    clone.param = {
        config_id: Number(result.config_id),
        config_url: newConfigUrl
    };
    return publishConfig(clone);
}
exports.prePublish = prePublish;
/**
 * 封装 http 模块，快速创建 ajax 请求
 * @param {*} method 请求方法，默认 GET
 * @param {*} server 服务器地址
 * @param {*} path 接口路径
 * @param     data 发送参数
 * @param     auth 登录信息
 * @param {*} callback 回调方法
 */
function ajax({ method, protocol, server, path, data, auth, origin, moreHeader, moreAction }) {
    let [hostname, port] = server.split(':');
    const options = {
        hostname: hostname,
        port: port,
        path: path,
        method: method,
        headers: Object.assign({ 'email': auth || '', 'Content-Type': 'application/json' }, moreHeader)
    };
    return new Promise((resolve, reject) => {
        let service = https;
        if (protocol === 'http') {
            service = http;
        }
        const ajax = service.request(options, (response) => {
            let result = '';
            response.setEncoding('utf8');
            response.on('data', (chunk) => {
                result += chunk;
            });
            response.on('end', () => {
                if (response.statusCode === 200) {
                    try {
                        let data = JSON.parse(result);
                        if (data.code && data.code !== 200) {
                            reject(data);
                        }
                        else if (data.error) {
                            reject(data.error);
                        }
                        else {
                            resolve(origin ? result : data);
                        }
                    }
                    catch (err) {
                        reject({
                            type: 'JSON',
                            msg: 'JSON parse error!'
                        });
                    }
                }
                else if (response.statusCode === 403) {
                    reject({
                        type: 'forbidden',
                        msg: 'Forbidden, you don`t have permission'
                    });
                }
                else {
                    reject({
                        type: response.statusCode,
                        msg: response.statusMessage
                    });
                }
            });
        });
        ajax.on('error', (err) => {
            msg('Request error occurred：' + err, constant_1.msgType.error);
            reject(err);
        });
        if (data) {
            ajax.write(JSON.stringify(data));
        }
        if (moreAction) {
            moreAction(ajax);
        }
        else {
            ajax.end();
        }
    });
}
/* Business Method */
// 按设定值生成能控制异步请求的并发数量的处理程序
function genLimitTask(self, taskLimit = 10) {
    let taskQuque = [];
    let taskCount = 0;
    function taskLimitCall(tasks, asyncHandle, callback, lastCallback) {
        if (taskCount < taskLimit && tasks.length) {
            taskCount++;
            asyncHandle.call(self, tasks.shift(), callback, lastCallback).finally(() => {
                taskCount--;
                taskLimitCall(tasks, asyncHandle, callback, lastCallback);
            });
        }
    }
    return function (prop, asyncHandle, callback, lastCallback) {
        taskQuque.push(prop);
        taskLimitCall(taskQuque, asyncHandle, callback, lastCallback);
    };
}
exports.genLimitTask = genLimitTask;
// 快速获取子节点的祖先 Env 节点
function getTreeEnv(item) {
    let grandpa = item.parent.parent.parent;
    if (grandpa instanceof config_item_1.TreeApp) {
        return grandpa.parent;
    }
    else {
        return grandpa;
    }
}
exports.getTreeEnv = getTreeEnv;
// 快速获取子节点的祖先 Collect 节点的 detail 信息
function getCollectDetail(item) {
    let parent = item.parent;
    if (parent instanceof config_item_1.TreeCollect) {
        return parent.detail;
    }
    else {
        return parent.parent.detail;
    }
}
exports.getCollectDetail = getCollectDetail;
// 快速生成常用查询参数
function genParam(item) {
    let detail = getCollectDetail(item);
    return {
        server: detail.server,
        authkey: detail.authkey,
        app: detail.app,
        appid: detail.appid,
        collect: detail.collect
    };
}
exports.genParam = genParam;
// 快速生成本地状态存储中的 Collect 节点的配置路径(通过物理路径)
function genCommonConfigPath(path) {
    let pathArr = path.split(libPath.sep);
    let collectName = pathArr.pop();
    let appName = pathArr.pop();
    let envName = pathArr.pop();
    return `_${envName}_${appName}_${collectName}`;
}
exports.genCommonConfigPath = genCommonConfigPath;
// 快速生成本地状态存储中的 Collect 节点的 commit code 列表配置路径(通过节点信息和请求参数)
function genItemConfigPath(item, post) {
    return `config_item_${getTreeEnv(item).label}_${post.app}_${post.collect}`;
}
exports.genItemConfigPath = genItemConfigPath;
// 快速生成本地物理文件的名称
function getConfigName(config) {
    let ext = getProp(config, 'config_file.ext') || '.json';
    let name = config.config_id + ext;
    return name;
}
exports.getConfigName = getConfigName;
// 解析 URL 字符串
function parseURL(href) {
    if (href.indexOf('http') < 0) {
        href = 'http://' + href;
    }
    let link = new libUrl.URL(href);
    return {
        host: link.host,
        port: link.port,
        path: link.pathname
    };
}
exports.parseURL = parseURL;
// 检测指定值是否未定义、为空
function checkValue(value, required) {
    if (value === undefined) {
        msg('当前行为已取消', constant_1.msgType.warn);
        return true;
    }
    if (!value && required) {
        msg('请输入必填项', constant_1.msgType.warn);
        return true;
    }
    return false;
}
exports.checkValue = checkValue;
/* vscode Method */
/**
 * 获取根路径
 */
function getRoot(vscode) {
    let rootPath = getProp(vscode, `workspace.workspaceFolders.${0}.uri.fsPath`) || '';
    // rootPath = vscode.workspace.rootPath;
    return rootPath;
}
exports.getRoot = getRoot;
/**
 * 读取本地状态存储内 config 相关信息
 */
function readConfigState(spaceState, key) {
    let configStr = spaceState.get(key) || '';
    let result = {};
    if (configStr) {
        try {
            result = JSON.parse(configStr);
        }
        catch (err) {
            console.log('JSON parse error!');
        }
    }
    return result;
}
exports.readConfigState = readConfigState;
/**
 * 读取和保存本地状态存储内 auth token 信息（添加时间戳用于判断是否过期）
 */
function readAuth(spaceState, key) {
    let authkey = spaceState.get('authkey_' + key) || '';
    if (authkey) {
        try {
            let authObj = JSON.parse(authkey);
            let duration = (Date.now() - authObj.timestamp) / (1000 * 60 * 60 * 24);
            if (duration < 30) {
                authkey = authObj.token;
            }
            else {
                authkey = '';
            }
        }
        catch (err) {
            authkey = '';
            console.log('JSON parse error!');
        }
    }
    return authkey;
}
exports.readAuth = readAuth;
function writeAuth(spaceState, key, authkey) {
    let authStr = JSON.stringify({
        timestamp: Date.now(),
        token: authkey
    });
    spaceState.update('authkey_' + key, authStr);
}
exports.writeAuth = writeAuth;
/**
 * 显示不同类型的信息提示
 */
function msg(info, type = constant_1.msgType.info) {
    let method = {
        info: 'showInformationMessage',
        error: 'showErrorMessage',
        warning: 'showWarningMessage'
    };
    return vscode.window[method[type]](info);
}
exports.msg = msg;
/**
 * 生成深浅不同主题配色下的资源文件路径
 *
 * @param   {string}    filename   资源文件
 * @return  {string}               完整资源文件路径，方便插件显示
 */
function lightRes(filename) {
    return libPath.join(__dirname, '..', 'resource', 'light', filename);
}
exports.lightRes = lightRes;
function darkRes(filename) {
    return libPath.join(__dirname, '..', 'resource', 'dark', filename);
}
exports.darkRes = darkRes;
/**
 * 创建 webview 面板
 * @param {*} context 扩展插件的上下文，方便全局注册
 * @param {*} label 标题
 * @param {*} column 编辑器中显示 webview 的位置
 * @param {*} path webview 里要显示 html 文件的路径
 * @param     onMessage webview 接受 message 信息的回调方法
 */
let webviewPanel;
function createWebview(context, label, column, path, onMessage) {
    if (!webviewPanel) {
        webviewPanel = vscode.window.createWebviewPanel('webView', label, column, {
            enableScripts: true
        });
        webviewPanel.webview.html = getWebViewContent(context, path);
    }
    else {
        webviewPanel.title = label;
        webviewPanel.reveal();
    }
    if (onMessage) {
        webviewPanel.webview.onDidReceiveMessage(onMessage, undefined, context.subscriptions);
    }
    webviewPanel.onDidDispose(() => {
        webviewPanel = undefined;
    });
    return webviewPanel;
}
exports.createWebview = createWebview;
/**
 * 从 HTML 文件读取能被 webview 加载的内容
 * @param {*} context 扩展插件的上下文
 * @param {*} templatePath 相对于插件根目录的html文件相对路径
 */
function getWebViewContent(context, templatePath) {
    const resourcePath = libPath.join(context.extensionPath, templatePath);
    const dirPath = libPath.dirname(resourcePath);
    let html = libFs.readFileSync(resourcePath, 'utf-8');
    // vscode 不支持直接加载本地资源，需要替换成其专有路径格式
    html = html.replace(/(<link.+?href="|<script.+?src="|<img.+?src=")(.+?)"/g, (m, $1, $2) => {
        return $1 + vscode.Uri.file(libPath.resolve(dirPath, $2)).with({ scheme: 'vscode-resource' }).toString() + '"';
    });
    return html;
}
exports.getWebViewContent = getWebViewContent;
/**
 * 执行回调函数
 */
function invokeCallback(panel, response) {
    panel.webview.postMessage({
        cmd: 'vscodeCallback',
        data: response
    });
}
exports.invokeCallback = invokeCallback;
/**
 * 所有消息处理函数，根据 message.cmd 来决定调用方法
 */
exports.messageHandler = {
    alert(global, message) {
        msg(message.info);
    },
    warn(global, message) {
        msg(message.info, constant_1.msgType.warn);
    },
    setConfig(global, message) {
        vscode.workspace.getConfiguration().update(message.key, message.value, true);
        invokeCallback(global.panel, message.response);
    }
};
//# sourceMappingURL=utils.js.map